{{page-title @model.map.name " | " (capitalize (t "edit"))}}

{{#if this.fastboot.isFastBoot}}
  <LoadingContainer />
{{else}}
  <Manage::EditManager as |editManager|>
    <div class="d-flex min-h-100">
      <Manage::SideBar class="order-last flex-shrink-1">
        <Manage::Visibility
          @model={{@model.map}}
          @teams={{@model.teams}}
          @hasIsDefault={{false}}
          @editablePanel={{editManager.editableField}}
          @savingPanel={{this.savingField}}
          @isAdmin={{this.user.isAdmin}}
          @areAllShowing={{this.allTeams}}
          @onChangeAll={{this.changeAll}}
          @saveIsPublic={{this.saveIsPublic}}
          @saveIsDefault={{this.saveIsDefault}}
          @saveTeam={{this.saveTeam}}
          @onEdit={{editManager.edit}}
          @onCancel={{editManager.cancel}}
        />

        <Manage::Toggle @title={{t "add features as pending"}} @id="add-features-as-pending" @value={{@model.map.addFeaturesAsPending}} @onSave={{this.saveAddFeaturesAsPending}} @savingField={{this.savingPanel}} />

        <Manage::Toggle @title={{t "show download links"}} @id="show-download-links" @value={{@model.map.showPublicDownloadLinks}} @onSave={{this.saveShowPublicDownloadLinks}} @savingField={{this.savingPanel}} />

        <Manage::Toggle @title={{capitalize (t "feature clustering")}} @id="feature-clustering" @value={{this.hasClusteringEnabled}} @onSave={{this.saveHasClusteringEnabled}} @savingField={{this.savingPanel}} />

        <Manage::ModelInfo @editablePanel={{editManager.editableField}} @savingPanel={{this.savingField}} @model={{@model.map}} @onSave={{this.save}} @onCancel={{editManager.cancel}} @onEdit={{editManager.edit}} />

        {{#if this.user.isAdmin}}
          <Manage::Toggle @title={{t "hide on main map"}} @id="hide-on-main-map" @value={{@model.map.hideOnMainMap}} @onSave={{this.saveHideOnMainMap}} @savingField={{this.savingPanel}} />
          <Manage::Toggle @title={{t "is index"}} @id="is-index" @value={{@model.map.isIndex}} @onSave={{this.saveIsIndex}} @savingField={{this.savingPanel}} />
        {{else}}
          <Manage::SideBarGroup @title={{t "hide on main map"}} @canEdit={{false}} class="container-group-hide-on-main-map">
            {{#if @model.map.hideOnMainMap}}
              {{t "yes"}}
            {{else}}
              {{t "no"}}
            {{/if}}
          </Manage::SideBarGroup>

          <Manage::SideBarGroup @title={{t "is index"}} @canEdit={{false}} class="container-group-is-index">
            {{#if @model.map.isIndex}}
              {{t "yes"}}
            {{else}}
              {{t "no"}}
            {{/if}}
          </Manage::SideBarGroup>
        {{/if}}
      </Manage::SideBar>

      <Manage::Container class="flex-grow-1" @breadcrumbs={{this.breadcrumbs}} @title={{capitalize (t "edit map")}}>
        <:content>
          {{#if this.alertList}}
            <Manage::Row>
              <AlertList @list={{this.alertList}} />
            </Manage::Row>
          {{/if}}

          <Manage::Row @name="article">
            <Manage::Article
              @title={{t "name and description"}}
              @editablePanel={{editManager.editableField}}
              @value={{@model.map.contentBlocks}}
              @onSave={{this.saveArticle}}
              @onCancel={{editManager.cancel}}
              @onEdit={{editManager.edit}}
              @onPictureUpload={{this.onPictureUpload}}
            />
          </Manage::Row>

          {{#unless this.showLegacyFields}}
            <Manage::Row @name="cover">
              <Manage::Cover
                @title={{t "cover photo"}}
                @model="Map"
                @modelId={{@model.map.id}}
                @editablePanel={{editManager.editableField}}
                @onSave={{this.saveCover}}
                @onEdit={{editManager.edit}}
                @onCancel={{editManager.cancel}}
                @value={{@model.map.cover}}
              />
            </Manage::Row>
          {{/unless}}

          {{#if this.showLegacyFields}}
            <Manage::Row @name="tag-line">
              <Manage::Text
                @title={{capitalize (t "tagline")}}
                @isMainValue={{true}}
                @value={{@model.map.tagLine}}
                placeholder={{capitalize (t "what is the map tagline?")}}
                @emptyError={{capitalize (t "this map has no tagline")}}
                @editablePanel={{editManager.editableField}}
                @savingPanel={{this.savingField}}
                @onSave={{this.saveTagLine}}
                @onEdit={{editManager.edit}}
                @onCancel={{editManager.cancel}}
              />
            </Manage::Row>

            <Manage::Row @name="cover">
              <h2 class="capitalize-first-letter">{{t "cover photos"}}</h2>
              <div class="form-group mt-2">
                <Input::PictureAuto @model="Map" @modelId={{@model.map.id}} class="mb-3 square-cover" @createImage={{this.createImage}} @value={{@model.map.squareCover}} @save={{this.saveSquareCover}} />

                <Input::PictureAuto @model="Map" @modelId={{@model.map.id}} class="cover mb-3" @createImage={{this.createImage}} @value={{@model.map.cover}} @save={{this.saveLegacyCover}} />
              </div>
            </Manage::Row>

            <Manage::Row @name="start-date">
              <Manage::Date
                @allowUnset={{true}}
                @title={{t "start date"}}
                @isMainValue={{true}}
                @editablePanel={{editManager.editableField}}
                @savingPanel={{this.savingField}}
                @onSave={{this.saveStartDate}}
                @onEdit={{editManager.edit}}
                @onCancel={{editManager.cancel}}
                @value={{@model.map.startDate}}
              />
            </Manage::Row>

            <Manage::Row @name="end-date">
              <Manage::Date
                @title={{t "end date"}}
                @allowUnset={{true}}
                @isMainValue={{true}}
                @editablePanel={{editManager.editableField}}
                @savingPanel={{this.savingField}}
                @onSave={{this.saveEndDate}}
                @onEdit={{editManager.edit}}
                @onCancel={{editManager.cancel}}
                @value={{@model.map.endDate}}
              />
            </Manage::Row>
          {{/if}}

          <Manage::Row @name="icon-sets">
            <Manage::SelectList
              @isMainValue={{true}}
              @title={{t "icon sets"}}
              @list={{@model.iconSets}}
              @emptyMessage={{t "The default icon sets will be used."}}
              @isEnabled={{@model.map.iconSets.useCustomList}}
              @values={{@model.map.iconSets.list}}
              @defaultValues={{@model.defaultIconSets}}
              @route="browse.icons.set"
              @editablePanel={{editManager.editableField}}
              @savingPanel={{this.savingField}}
              @onSave={{this.saveIconSets}}
              @onEdit={{editManager.edit}}
              @onCancel={{editManager.cancel}}
            />
          </Manage::Row>

          <Manage::Row @name="base-maps">
            <Manage::SelectList
              @isMainValue={{true}}
              @title={{t "base maps"}}
              @list={{@model.baseMaps}}
              @emptyMessage={{t "default-base-maps-used-message"}}
              @isEnabled={{@model.map.baseMaps.useCustomList}}
              @values={{@model.map.baseMaps.list}}
              @defaultValues={{@model.defautBaseMaps}}
              @editablePanel={{editManager.editableField}}
              @savingPanel={{this.savingField}}
              @onSave={{this.saveBaseMaps}}
              @onEdit={{editManager.edit}}
              @onCancel={{editManager.cancel}}
            />
          </Manage::Row>

          <Manage::Row @name="mapping area">
            <Manage::Area
              @title="mapping area"
              @help={{t "help.map.area"}}
              @baseMaps={{@model.map.baseMaps.list}}
              @value={{@model.map.area}}
              @editablePanel={{editManager.editableField}}
              @savingPanel={{this.savingField}}
              @onChange={{this.changeExtent}}
              @onEdit={{editManager.edit}}
              @onCancel={{editManager.cancel}}
            />
          </Manage::Row>

          <Manage::Row @name="mask">
            <Manage::Mask
              @title={{t "mask points"}}
              @isMainValue={{true}}
              @editablePanel={{editManager.editableField}}
              @savingPanel={{this.savingField}}
              @onSave={{this.saveMask}}
              @onEdit={{editManager.edit}}
              @onCancel={{editManager.cancel}}
              @value={{@model.map.mask}}
              @maps={{@model.indexedMaps}}
            />
          </Manage::Row>

          <Manage::Row @name="license">
            <Manage::License
              @title={{t "license"}}
              @isMainValue={{true}}
              @editablePanel={{editManager.editableField}}
              @savingPanel={{this.savingField}}
              @onSave={{this.saveLicense}}
              @onEdit={{editManager.edit}}
              @onCancel={{editManager.cancel}}
              @value={{@model.map.license}}
            />
          </Manage::Row>

          <Manage::Row @name="embedded-map">
            <Manage::FieldContainer @title={{t "embedded map"}} @isDisabled={{true}} @isSaveDisabled={{true}} class="container-group-area">
              <:view>
                <Manage::EmbedMapCode @map={{@model.map}} class="w-100" />
              </:view>
            </Manage::FieldContainer>
          </Manage::Row>
        </:content>
      </Manage::Container>
    </div>
  </Manage::EditManager>
{{/if}}